#!/usr/local/bin/perl -w
use strict; use Tk; use IO::File;

my $pattern; my $msg = "";
my $filename = "pruef.db";
my @matches = (); my $matchcount = 0;
my %record = ();
my %entries =();
my @attr = ("Name", "Vorname", "MatrNr", 
            "Studiengang", "Datum", "Uhrzeit",
            "Beisitzer", "Vorlesungen");
foreach (@attr) { $record{$_} = ""; }

my $main = MainWindow->new();
$main->title("Pruefungsdaten");

my $f = $main->Frame->pack(-side => "bottom");
$main->Label(-textvariable => \$msg, -relief => "groove", 
             -borderwidth => 4, -foreground => 'red' 
            )->pack(-side => "bottom", -fill => "x");

$f->Button(-text => "Show", -command => \&show_match
          )->pack(-side => "right");

$f->Button(-text => "Exit", -command => sub { exit; }
          )->pack(-side => "right");
$f->Button(-text => "Save", -command => \&save
          )->pack(-side => "right");
foreach ("Suchbegriff", @attr) {
   my $e = $main->Frame()->pack(-side => "top", -expand => 1,
                              -fill => 'both');
   my $e_l = $e->Frame()->pack(-side => "left", -expand => 1,
                              -fill => 'both');
   my $e_r = $e->Frame()->pack(-side => "right", -expand => 1,
                              -fill => 'both');

   $e_l->Label(-text => "$_: ", -relief => "groove",
                    -anchor => "w", -width => 15
            )->pack(-side => "left");
   if ( "$_" eq "Suchbegriff" ) {
     $entries{$_} = $e_r->Entry(-width => 30, 
                                   -textvariable => \$pattern
                                  )->pack(-side => "right");
     $entries{$_}->bind('<Return>', [ \&search, \$pattern ]);
   } else {
     $entries{$_} = $e_r->Entry(-width => 30, -textvariable => \$record{$_}
                )->pack(-side => "right");
   }
}

MainLoop;

sub save {
  my $file = new IO::File;
  if (! ($file->open(">>$filename"))) {
     $msg = "ERROR: Could not open file $filename";
     return;
  };
 my $first = 1;
 foreach (@attr) {
    if ( ! $first ) { print $file "^"; 
    } else { $first = 0 };
    print $file "$record{$_}";
 }
    print $file "\n";
 $msg = "Gespeichert!"
}

sub search {
   # Remember: $_[0] is calling widget
   my $pat_ref = $_[1]; 
   my $pat = $$pat_ref;
   print "$pat\n";
   my $file = new IO::File;
  if (! ($file->open("<$filename"))) {
     $msg = "ERROR: Could not open file $filename";
     return;
  };
  $matchcount = 0;
  while (my $line = <$file>) {
    chomp $line;
    next if (! ($line =~ /$pat/) );
    push(@matches, \$line);
    $matchcount++;
  }
  $msg = "$matchcount Treffer";
}

sub show_match {
  print "matchcount = $matchcount\n";
  $matchcount--;
  if ($matchcount < 0) {
    $msg = "Keine (weiteren) Treffer";
    $matchcount = 0;
    return;
  }
print "Show\n";
  my $lineref = $matches[$matchcount];
  my $line = $$lineref;
  print ">>$line<<\n";
    
  my @values = split(/\^/, $line); my $i = 0;
  foreach (@attr) {
    $record{$_} = $values[$i];
    $i++;
  }
}
