#!/usr/local/bin/perl -w
use strict; use IO::File; use Tk;
my $filename =""; my $info = "";
my $main = new MainWindow;
$main->title("Simple Text Editor");
my $f = $main->Frame()->pack(-side => "top", -fill => "x");
$f->Label(-text => "Filename:"
         )->pack(-side => "left", -anchor => "w");
$f->Entry(-textvariable => \$filename
         )->pack(-side => "left", -anchor => "w", 
                 -fill => "x", -expand => 1);
$f->Button(-text => "Exit", -command => sub { exit; }
          )->pack(-side => "right");
$f->Button(-text => "Clear", -command => \&clear
          )->pack(-side => "right");
$f->Button(-text => "Save", -command =>\&save_file 
          )->pack(-side => "right", -anchor => "e");
$f->Button(-text => "Load", -command =>\&load_file 
          )->pack(-side => "right", -anchor => "e");
$main->Label(-textvariable => \$info, -relief => "ridge"
            )->pack(-side => "bottom", -fill => "x");
my $txt = $main->Scrolled("Text")
             ->pack(-side => "bottom", -fill => "both", -expand => 1);
MainLoop;

sub clear { $txt->delete("1.0","end"); $filename=""; $info = ""; }
sub load_file {
  $info = "Loading file '$filename' ... ";
  $txt->delete("1.0", "end");
  if ($filename eq "") { 
     $txt->insert("end", "Give filename to load\n"); return;
  };
  my $file = new IO::File;
  if (! ($file->open("<$filename"))) {
     $txt->insert("end", "ERROR: Could not open $filename\n");
     return;
  }
  while (<$file>) { $txt->insert("end", $_); }
  $file->close();
  $info = "File '$filename' loaded";
}
sub save_file {
  $info = "Saving '$filename'";
  my $file = new IO::File;
  $file->open(">$filename");
  $file->write($txt->get("1.0","end"));
  $file->close();
  $info = "Saved.";
}
