#!/usr/local/bin/perl -w
use strict; use IO::File; use Tk;

my $main = new MainWindow;
my $fr = $main->Frame()->pack(-side => "right");
my $txt = $main->Text(-wrap => "word", -width => 45, -height => 13,
    -font => "-adobe-courier-bold-o-normal--18-180-75-75-m-110-iso8859-1"
                     )->pack(-side => "left");
$fr->Button(-text => "Exit", -command => sub { exit; }
          )->pack(-side => "bottom", -fill => "x");
$fr->Button(-text => "Load", -command =>\&load_file 
           )->pack(-side => "bottom", -fill => "x");

$fr->Button(-text => "tagDel", 
            -command => sub { $txt->tagDelete('color', 'heading'); }
           )->pack(-side => "bottom", -fill => "x");
$fr->Button(-text => "tagRem", 
            -command => sub { $txt->tagRemove('color', '5.0', '5.5'); }
           )->pack(-side => "bottom", -fill => "x");

$fr->Button(-text => "color", -command => [ \&addtag, 'color']
           )->pack(-side => "bottom", -fill => "x");
$fr->Button(-text => "heading", -command => [ \&addtag, 'heading']
          )->pack(-side => "bottom", -fill => "x");

$txt->tagConfigure('color', -foreground => "blue");
$txt->tagConfigure('heading', -spacing1 => 10, 
                              -font => "lucidasans-bold-18");
MainLoop;

sub addtag {
  my $tag = $_[0];
  $txt->tagAdd($tag, '1.0', '1.0 lineend',
                     '5.0', '5.0 lineend',
                     '7.0', '7.0 lineend');
}

sub load_file {
  $txt->delete("1.0", "end");
  my $file = new IO::File;
  if (! ($file->open("faust"))) {
     $txt->insert("end", "ERROR: Could not open faust\n");
     return;
  }
  while (<$file>) { $txt->insert("end", $_); }
  $file->close();
}
