#!/usr/local/bin/perl -w
use strict; use IO::File; use Tk;

my @colors = ("blue", "red", "green");
my $main = new MainWindow;
my $fr_upper = $main->Frame()->pack(-side => "top");
my $fr_lower = $main->Frame()->pack(-side => "bottom", -fill => "x");
my $fr_upper_left = $fr_upper->Frame()->pack(-side => "left");
my $fr_upper_right = $fr_upper->Frame()->pack(-side => "right");
my $stack = $fr_upper_right->Frame(-borderwidth => 5, 
                       -background => "green")->pack(-side => "top");
my $txt = $fr_upper_left->Text(-wrap => "word", 
    -width => 42, -height => 16,
    -font => "-adobe-courier-bold-o-normal--18-180-75-75-m-110-iso8859-1"
                     )->pack(-side => "left");
$fr_lower->Button(-text => "Exit", -command => sub { exit; }
                 )->pack(-side => "right", -expand => 1, -fill => "x");
$fr_lower->Button(-text => "Load", -command =>\&load_file 
                 )->pack(-side => "left", -expand => 1, -fill => "x");

##############################################
foreach my $c (@colors) {
$fr_upper_right->Button(-text => "Lower $c", -background => "$c",
                        -command => sub { $txt->tagLower("$c"); }
                       )->pack(-side => "top", -fill => "x");
$fr_upper_right->Button(-text => "Raise $c", -background => "$c",
                        -command => sub { $txt->tagRaise("$c"); }
                       )->pack(-side => "top", -fill => "x");

$stack->Button(-text => "$c", -command => [ \&addtag, "$c"]
              )->pack(-side => "bottom", -fill => "x");

$txt->tagConfigure("$c", -foreground => "$c");
}
##############################################
MainLoop;

sub addtag {
  my $tag = $_[0];
  $txt->tagAdd($tag, '1.0', '1.0 lineend', '5.0', '5.0 lineend',
                     '7.0', '7.0 lineend');
}
sub load_file {
  $txt->delete("1.0", "end");
  my $file = new IO::File;
  if (! ($file->open("faust"))) {
     $txt->insert("end", "ERROR: Could not open faust\n");
     return;
  }
  while (<$file>) { $txt->insert("end", $_); }
  $file->close();
}
