#!/usr/local/bin/perl -w
use strict; 
use Tk;
my @tags =( qw(blue bgstipple fgstipple underline overstrike destroy up down) );

my $main = new MainWindow;
my $fr = $main->Frame()->pack(-side => "right");
my $txt = $main->Text(-wrap => "word", -width => 40, -height => 16,
    -font => "-adobe-courier-bold-o-normal--18-180-75-75-m-110-iso8859-1"
                     )->pack(-side => "left");
$fr->Button(-text => "Exit", -command => sub { exit; }
          )->pack(-side => "bottom", -fill => "x");
foreach (@tags) { 
  $fr->Button(-text => $_, -command => [ \&addTag,  $_ ]
             )->pack(-side => "top", -fill => "x");
}
$txt->tagConfigure('blue', -foreground => "blue");
$txt->tagConfigure('bgstipple', -bgstipple => "gray50",
                                -background => "green");
$txt->tagConfigure('fgstipple', -fgstipple => "gray75",
                                -foreground => "red");
$txt->tagConfigure('up', -offset => 6);
$txt->tagConfigure('down', -offset => -6);
$txt->tagConfigure('underline', -underline => 1);
$txt->tagConfigure('destroy', -elide => 1);
$txt->tagConfigure('overstrike', -foreground => "red", -overstrike => 1);
MainLoop;

sub addTag {
  my $tag = $_[0];
  if ($txt->tagRanges('sel')) {
     $txt->tagAdd($tag, 'sel.first', 'sel.last');
     print "Foreground Configuration for Tag $tag:\n";
     my $l = $txt->tagConfigure($tag, -foreground);
     my $option = shift(@$l);
     my $value = pop(@$l);
     print("$option", "=", "$value\n") if (defined $value);
  }
}
