#!/usr/local/bin/perl -w
use strict; use IO::File; use Tk;

my $main = new MainWindow;
my $fr = $main->Frame()->pack(-side => "bottom", -fill => "x");
my $txt = $main->Scrolled("Text", -wrap => "word", -width => 42, 
                          -height => 24, -font => "lucidasans-bold-14"
                     )->pack(-side => "top");
$fr->Button(-text => "Exit", -command => sub { exit; }
          )->pack(-side => "right", -expand => 1, -fill => "x");
$fr->Button(-text => "Configure", -command => sub { 
            $txt->tagConfigure('blue', -foreground => "blue");
                                                   }
          )->pack(-side => "right", -expand => 1, -fill => "x");
$fr->Button(-text => "Load", -command =>\&load_file 
           )->pack(-side => "left", -expand => 1, -fill => "x");

$txt->tagConfigure('heading1', -spacing1 => 2, -spacing2 => 2, 
                   -spacing3 => 2, -font => "lucidasans-bold-24");
$txt->tagConfigure('heading2', -spacing1 => 2, -spacing2 => 2, 
                   -spacing3 => 1, -font => "lucidasans-bold-18");
$txt->tagConfigure('italic', -font => "lucidasans-bolditalic-14");
# $txt->tagConfigure('blue', -foreground => "blue");
$txt->tagConfigure('red', -foreground => "red");
MainLoop;

sub load_file {
  $txt->delete("1.0", "end");
  my $file = new IO::File;
  if (! ($file->open("text.tex"))) {
     $txt->insert("end", "ERROR: Could not open text.tex\n");
     return;
  }
  while (<$file>) { 
    chomp;
    if ("$_" eq "") { $txt->insert("end", "\n\n"); next;}
    if (/^\\section/) { s/^\\section{(.*)}/$1/; 
      $txt->insert("end", "$_", 'heading1'); 
      next;
    };
    if (/^\\subsection/) { s/^\\subsection{(.*)}/$1/; 
      $txt->insert("end", "$_", 'heading2'); 
      next;
    };
    if (/^\\textit{/){ s/^\\textit{(.*?)}/$1/;
       $txt->insert("end", "\n\"", 'red', "$_ ", ['italic', 'blue'], 
                           "\"", 'red'); 
       next;
    }
    $txt->insert("end", "$_ ", 'blue'); 
  }
  $file->close();
}
