#!/usr/local/bin/perl -w
use strict; use IO::File; use Tk;

my $main = new MainWindow;
my $pattern = "";
my $fr1 = $main->Frame()->pack(-side => "bottom", -fill => "x");
my $fr2 = $main->Frame()->pack(-side => "bottom", -fill => "x");
my $fr3 = $main->Frame()->pack(-side => "bottom", -fill => "x");
my $txt = $main->Scrolled("Text", -wrap => "word", -width => 42, 
                          -height => 18, -font => "lucidasans-bold-14"
                     )->pack(-side => "top");
$fr1->Button(-text => "Exit", -command => sub { exit; }
          )->pack(-side => "right", -expand => 1, -fill => "x");
$fr1->Button(-text => "Load File", -command => \&load_file 
           )->pack(-side => "left", -expand => 1, -fill => "x");
$fr2->Label(-text => "Pattern:")->pack(-side => "left");
$fr2->Entry(-textvariable => \$pattern)->pack(-side => "left");
$fr2->Button(-text => "Search exact", 
             -command => [ \&search, '-exact']
            )->pack(-side => "right");
$fr2->Button(-text => "Search regexp", 
             -command => [ \&search, '-regexp' ]
            )->pack(-side => "right");

$txt->tagConfigure("found", -foreground => "red");

MainLoop;

sub load_file {
  $txt->delete("1.0", "end");
  my $file = new IO::File;
  if (! ($file->open("faust"))) {
     $txt->insert("end", "ERROR: Could not open faust\n");
     return;
  }
  while (<$file>) { $txt->insert("end", $_); }
  $file->close();
}

sub search {
   my ($switch) = @_;
   my $length = 0;
   my (@list) = $txt->tagRanges("found");
   if ($#list > 0) { $txt->tagRemove("found", $list[0], $list[1]) ;}

   my $index = $txt->search("$switch", -count => \$length, "$pattern", "1.0");
   if ($length > 0) {
      $txt->tagAdd("found", "$index", "$index + $length chars");
   }
}

