#!/usr/local/bin/perl -w
use strict; use IO::File; use Tk;

my $main = new MainWindow;
my $pattern = "";
my $oldpattern = "";
my ($line, $col) = (1,0);
my $start = "$line.$col";
my $msg = "";
my $matchnr = 0;
$main->Label(-textvariable => \$msg, -relief => "groove", 
             -borderwidth => 4, -foreground => 'red' 
            )->pack(-side => "bottom", -fill => "x");
my $fr1 = $main->Frame()->pack(-side => "bottom", -fill => "x");
my $fr2 = $main->Frame()->pack(-side => "bottom", -fill => "x");
my $fr3 = $main->Frame()->pack(-side => "bottom", -fill => "x");
my $txt = $main->Scrolled("Text", -wrap => "word", -width => 43, 
                          -height => 18, -font => "lucidasans-bold-14"
                     )->pack(-side => "top", -expand => 1,
                             -fill => 'both');
$fr1->Button(-text => "Exit", -command => sub { exit; }
          )->pack(-side => "right", -expand => 1, -fill => "x");
$fr1->Button(-text => "Load File", -command => \&load_file 
           )->pack(-side => "left", -expand => 1, -fill => "x");
$fr2->Label(-text => "Pattern:")->pack(-side => "left");
$fr2->Entry(-textvariable => \$pattern
           )->pack(-side => "left", -expand => 1, -fill => 'x');
$fr2->Button(-text => "Search exact", 
             -command => [ \&search, '-exact', \$pattern]
            )->pack(-side => "right");
$fr2->Button(-text => "Search regexp", 
             -command => [ \&search, '-regexp', \$pattern ]
            )->pack(-side => "right");

$txt->tagConfigure("found", -foreground => "red");

MainLoop;

sub load_file {
  $txt->delete("1.0", "end");
  my $file = new IO::File;
  if (! ($file->open("faust"))) {
     $msg = "ERROR: Could not open file faust";
     return;
  }
  while (<$file>) { $txt->insert("end", $_); }
  $file->close();
}

sub search {
   my $switch = $_[0]; my $pat_ref = $_[1];
   my $length = 0;
   my (@list) = $txt->tagRanges("found");
   if ($#list > 0) { $txt->tagRemove("found", $list[0], $list[1]) ;}

   if ($oldpattern ne $pattern) {
        ($line, $col) = (1,0);
        $start = "$line.$col";
        $oldpattern = "$pattern";
        $msg = "";
        $matchnr = 0;
   }
   my $index = $txt->search("$switch", -count => \$length, 
                            "$$pat_ref", "$start", "end");
   if ($length > 0) {
      $matchnr ++;
      $txt->tagAdd("found", "$index", "$index + $length chars");
      ($line = $index) =~ s/\..*//;
      ($col  = $index) =~ s/^[^.]*\.//;
      $col++; $start = "$line.$col"; 
      $msg = "Match Nr. $matchnr";
   } else {
      $msg = "End of text reached";
   }
}
